//
//  FlipsideViewController.h
//  oh_hw2
//
//  Created by Jieun Oh on 1/29/10.
//  Copyright Stanford University 2010. All rights reserved.
//

#include "Controls.h"

@protocol FlipsideViewControllerDelegate;


@interface FlipsideViewController : UIViewController {
	id <FlipsideViewControllerDelegate> delegate;
	
	IBOutlet UISlider * gravitySlider;
	IBOutlet UISlider * dampingSlider; 
	IBOutlet UISlider * ballSlider;
	IBOutlet UISlider * elasticitySlider; 
	IBOutlet UISwitch * clearSwitch; 
	
}


// action methods
- (IBAction)moveGSlider:(UISlider *)sender;
- (IBAction)moveDSlider:(UISlider *)sender;
- (IBAction)moveBSlider:(UISlider *)sender;
- (IBAction)moveESlider:(UISlider *)sender;
- (IBAction)triggerCSwitch:(UISwitch *)sender;

// set properties
@property (nonatomic, assign) id <FlipsideViewControllerDelegate> delegate;
@property (nonatomic, retain) IBOutlet UISlider * gravitySlider;
@property (nonatomic, retain) IBOutlet UISlider * dampingSlider;
@property (nonatomic, retain) IBOutlet UISlider * ballSlider;
@property (nonatomic, retain) IBOutlet UISlider * elasticitySlider;
@property (nonatomic, retain) IBOutlet UISwitch * clearSwitch;

- (IBAction)done;

@end


@protocol FlipsideViewControllerDelegate
- (void)flipsideViewControllerDidFinish:(FlipsideViewController *)controller;
@end

