//
//  FlipsideViewController.m
//  oh_hw2
//
//  Created by Jieun Oh on 1/29/10.
//  Copyright Stanford University 2010. All rights reserved.
//

#import "FlipsideViewController.h"
#include "Controls.h"

@implementation FlipsideViewController

@synthesize delegate;

@synthesize gravitySlider;
@synthesize dampingSlider;
@synthesize ballSlider;
@synthesize elasticitySlider;
@synthesize clearSwitch;


-(IBAction)moveGSlider:(UISlider *)sender
{
	Controls* c = Controls::instance();
	c->setGravity(sender.value);
}

-(IBAction)moveDSlider:(UISlider *)sender
{
	Controls* c = Controls::instance();
	c->setDamping(sender.value);
}


- (IBAction)moveBSlider:(UISlider *)sender
{
	Controls* c = Controls::instance();
	c->setBall(sender.value);
	c->setClearBalls(true);
}

- (IBAction)moveESlider:(UISlider *)sender
{
	Controls* c = Controls::instance();
	c->setElasticity(sender.value);
}


-(IBAction)triggerCSwitch:(UISwitch *)sender
{
	Controls* c = Controls::instance();
	c->setClear(sender.isOn);
}



- (void)viewDidLoad {
    [super viewDidLoad];
    // self.view.backgroundColor = [UIColor viewFlipsideBackgroundColor];  
    
	Controls* c = Controls::instance();

	[gravitySlider setValue: c->getGravity()];
	[dampingSlider setValue: c->getDamping()];
	[ballSlider setValue: c->getBall()];
	[elasticitySlider setValue: c->getElasticity()];
	[clearSwitch setOn: c->getClear()];
}


- (IBAction)done {
	[self.delegate flipsideViewControllerDidFinish:self];	
}


/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
