//
//  Controls.h
//  oh_hw2
//
//  Created by Jieun Oh on 2/1/10.
//  Copyright 2010 Stanford University. All rights reserved.
//

#ifndef __CONTROLS__
#define __CONTROLS__

class Controls {

public:
	
	static Controls *instance();
	static Controls *ourInstance;
	
	void setGravity( float g);
	void setDamping( float d);
	void setBall( float b);
	void setClear( bool c);
	void setElasticity( float e);
	
	void setClearTouches( bool ct);
	void setClearBalls( bool cb);

	
	float getGravity();
	float getDamping();
	float getBall(); 
	float getElasticity();
	bool getClear(); 
	
	
	bool getClearTouches(); 
	bool getClearBalls(); 

	
	
private:
	Controls();
	~Controls();

	float mGravity;      // bassed on tilt, between 0.0 and 0.1
	float mDamping;      // friction of surface, between 0.0 and 1.0 
	float mBall;         // ball size
	float mClear;        // balls: shake to clear (true or false) 
	float mElasticity;
	bool mClearTouches;  // for transitioning from FlipView to MainView
	bool mClearBalls;    // for after changing the ball size, refresh screen 
	
};

#endif