//
//  ES1Renderer.h
//  hw2_graphics
//
//  Created by slork on 1/12/10.
//  Copyright Stanford University 2010. All rights reserved.
//

#import "ESRenderer.h"

#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#import "Stk.h"
// #import "SineWave.h"
// #import "ADSR.h"
// #import "NRev.h"
#import "StifKarp.h"
// #import "Brass.h"
// #import "Drummer.h"
// #import "PercFlut.h"
// #import "Simple.h"
#import "Vector2D.h"
#import "Controls.h"


using namespace stk;
// Controls* c; 


struct Keyloc {
	int key;
	float x;
	float y;
};

struct Ball {
	Vector2D pos; 
	Vector2D vel;
	float freqID;
	float alpha; // dependent on velocity: if velocity is below threshold, fades to 0. 
	// bool brassOn; 
};

struct AudioData {
	
	// SineWave * sineWave;
	// ADSR * adsr;
	// NRev * reverb;
	StifKarp * sk;      // for initial ball launch
	StifKarp * sk_wall; // for ball-wall collision
	StifKarp * sk_ball; // for ball-ball collision
	// PercFlut * pf; 
	// Simple * sp; 
	// Brass * br; 
	// Drummer * dr;
	
};

@interface ES1Renderer : NSObject <ESRenderer>
{
	struct AudioData audioData;

@private
	EAGLContext *context;
	
	// The pixel dimensions of the CAEAGLLayer
	GLint backingWidth;
	GLint backingHeight;
	
	// The OpenGL names for the framebuffer and renderbuffer used to render to this view
	GLuint defaultFramebuffer, colorRenderbuffer;
}

- (void) render;
- (BOOL) resizeFromLayer:(CAEAGLLayer *)layer;

@end
