/*
 *  Vector2d.h
 *  oh_hw2
 *
 *  Created by Jieun Oh on 1/31/10.
 *  Copyright 2010 Stanford University. All rights reserved.
 *
 */



class Vector2D
	{
	public:
		Vector2D() {setAll(0);}
		Vector2D( GLfloat _x, GLfloat _y) {set(_x, _y);}
		Vector2D( const Vector2D & rhs) {*this = rhs;}
		
	public:
		void set (GLfloat _x, GLfloat _y) { x=_x, y=_y;}
		void setAll (GLfloat val) {x=y=val;}
		
	public:
		GLfloat & operator [] (int index)
		{ if(index==0) return x; 
			if(index==1) return y; 
			return nowhere;
		}
		
		const GLfloat & operator [] (int index ) const  // use without worrying about changing anything inside. "read only"
		{ if(index==0) return x; 
			if(index==1) return y; 
			return zero;
		}
		
		const Vector2D & operator = (const Vector2D & rhs) 
		{x=rhs.x; y=rhs.y;} 
		
		Vector2D operator+ (const Vector2D & rhs) const
		{ Vector2D result = *this; resut += rhs; return result; }
		
		Vector2D operator- (const Vector2D & rhs) const 
		{ Vector2D result = *this; resut -= rhs; return result; }
		
		void operator* (GLfloat scalar) const 
		{ Vector2D result = *this; resut *= scalar; return result; }
		
		void operator+= (const Vector2D & rhs) const
		{ x += rhs.x; y += rhs.y;}
		void operator-= (const Vector2D & rhs) const
		{ x -= rhs.x; y -= rhs.y;}
		void operator*= (GLfloat scalar)
		{ x *= scalar.x; y *= scalar.y; }
		
		// magnitude
		GLfloat magnitude() const
		{ return ::sqrt(x*x + y*y); }
		
		// normalize
		void normalize()
		{
			GLfloat mag = magnitude();
			if (mag ==0) return;
			*this *= 1/mag; 
		}
		
		// dot product
		// 2d angles (use arctan function. atan2 version? use atan) 
		// libraries for vector and matrix manipulation. stanford cs has versions
		
	private:
		GLfloat x;
		GLfloat y;
		
		static GLfloat nowhere; 
		static const GLfloat zero; 
	};

/*
 int main()
 {
 Vector2D x;
 x[0] = 3;
 return 0; 
 
 }
 */
